import type { TaskEither } from "fp-ts/lib/TaskEither";
import type { Job } from "./job";
import type { D } from "../util";

export enum TestType {
  EMAIL = "email",
  PING = "ping",
  HEALTHCHECK = "healthcheck",
  DNS = "dns",
}

export interface Schedule {
  every: D.Duration;
  jitter: D.Duration;
}

export interface Test {
  name: string;
  type: TestType;
  job: Job;
  schedule: Schedule;
}

export type Testable<T extends Job> = (job: T) => TaskEither<Error, boolean>;
