import type { Duration, Result } from "../util";

export enum PublisherType {
  DISCORD = "discord",
  NTFY = "ntfy",
}

export interface DiscordPost {
  webhook: string;
  role_id: string;
}

export interface NtfyPost {
  webhook: string;
}

export type PublisherPost = DiscordPost | NtfyPost;

export interface Publisher {
  type: PublisherType;
  at: Duration;
  post: PublisherPost;
}

export interface ResultPublishable {
  publish(testResult: Result<boolean, Error>): void;
}
